import { HttpLink } from 'apollo-link-http'
import { ApolloLink } from 'apollo-link'
import { ApolloClient } from 'apollo-client'
import { InMemoryCache, IntrospectionFragmentMatcher } from 'apollo-cache-inmemory'
import schema from './schemaV2.json'
import VueApollo from 'vue-apollo'
import Vue from 'vue'

Vue.use(VueApollo)

const fragmentMatcher = new IntrospectionFragmentMatcher({
  schema
})

const httpLink = new HttpLink({
  uri: 'https://api.dokoma.com/api/v1/graphql/salle_classe'
})

const middlewareLinkPlus = new ApolloLink((operation, forward) => {
  let headers = { 'Accept-Language': 'FR-QC' }
  headers.Authorization = 'Bearer eyJhbGciOiJIUzI1NiJ9.eyJqdGkiOiJjYmQzNWIyNC1kMzdmLTQ3YjktYWNkZS04YWNmNWFhODkyOWMiLCJzdWIiOiI2Iiwic2NwIjoic2FsbGVfY2xhc3NlX3VzYWdlciIsImF1ZCI6bnVsbCwiaWF0IjoxNjExMjQwMzYzLCJleHAiOjE2MTEzMjY3NjN9.AfuYPxohPXaJODYmwCFiJ4dJBd8gIhYHHimSJVp1OFQ'
  operation.setContext({
    headers: headers
  })
  return forward(operation)
})

export const apolloClient = new ApolloClient({
  link: middlewareLinkPlus.concat(httpLink),
  cache: new InMemoryCache({ fragmentMatcher })
})

export default new VueApollo({
  defaultClient: apolloClient
})
